# 🌟 Welcome to DataFormsJS!

**Thanks for visiting!**

_If you are seeing this message then you are one of the earliest visitors!_ 🌠👍

DataFormsJS is a new JavaScript Framework and Standalone React and Web Components. DataFormsJS is small in size, easy to learn, designed for fast development, and to make for a great experience for both developers and end-users. Although it’s new (first published in November of 2019) DataFormsJS was written and used over many years and is extremely stable containing a large number of unit tests.

This repository contains DataFormsJS’s Framework, Example Pages, and Unit Tests. The main website exists on another repository.

## 🚀 Getting Started

**Getting started with DataFormsJS is extremely easy.**

Develop online using the code playground: <a href="https://www.dataformsjs.com/#/en/playground" target="_blank">https://www.dataformsjs.com/#/en/playground</a>

Download a template file using scripts from a CDN: <a href="https://www.dataformsjs.com/#/en/getting-started" target="_blank">https://www.dataformsjs.com/#/en/getting-started</a>

Download this Repository. It’s small to download because this repository has no local dependencies and loads Handlebars, Vue, and React from a CDN. To run all example files Node needs to be installed and then you can run one of the following servers:

* examples/server.js
* test/server.js

## 🤝 Contributing

**All contributions are welcome.** For major changes including breaking changes to existing code or updating existing graphics and files, please open an issue first to discuss what you would like to change. Some examples of items to contribute:

* Typos and Grammar Mistakes - If you see any please fix and submit.
* Documentation and Tutorials. Currently most documentation is in the quick reference section and code comments so a lot of documentation will be needed and written over time.
* Many more examples will be developed in the future. If you have ideas please submit.
* Additional Unit Tests and Testing Methods - Core Framework files and features are Unit Tested however every line of code should be Unit Tested in all files. Currently there is are no Unit Tests for Vue, React, and Web Components.
* Additional Scripts, React Components, Web Components, and Features.
* New Ideas - If you have ideas on how to improve then please open an issue to discuss.

The [docs/to-do-list.txt] file contains the full list of items that are currently pending and is good place to start.

## <span style="color:green;">$</span> Paid Translators Needed!

**Are you fluent in English and another language? <a href="https://www.fastsitephp.com/en/translators-needed" target="_blank">If so then please get in touch</a>.**

DataFormsJS is looking for paid translators so that it can be translated into multiple languages quickly. Translations can be done in many steps so even if you have just an hour or two it will be enough to help and earn some money.

## :question: FAQ

**Why was DataFormsJS Created?**

Initial development and use of DataFormsJS occurred privately in 2013 to allow for rapid development of high quality and bug free Single Page Applications (SPA). DataFormsJS was designed to have a small size, great performance, and to be much faster for development compared to other Frameworks. A few of the reasons for fast development include displaying JSON services using only Markup and Templating (Handlebars, Underscore, etc.) and defining App and Site features using HTML attributes and small JavaScript Plugins.

Early versions of DataFormsJS were used a number of companies in many different types of apps. 

Now that both React and Vue have become very popular separate React Components have been developed to help with React Development and the Framework has been expanded to support Vue. Additionally separate Web Components have been developed to allow for similar functionality in modern browsers without using a JavaScript framework.

**Why did it take so long to release?**

The author of DataFormsJS had a number of busy jobs at the time and was also working on another large project at the same time (<a href="https://www.fastsitephp.com/en/" target="_blank">FastSitePHP</a>).

**How large is DataFormsJS?**

_All sizes are based on minified scripts and gzip compression from the web server._

* **DataFormsJS Framework – 9.8kb** (120 kb uncompressed and full version)
* Additional files (controllers, plugins, etc) are typically only 1-3 kb each.
* In general when using the Framework expect about 15 kb for the intial page load, and then several kb for additional pages that load extra plugins, pages, controllers, etc.
* React (All Components in JavaScript) – 6.1 kb
* Individual React Components are between 3 and 12 KB when uncompressed and including comments.
* Web Components are typically around 1 to 3 KB each, typically you will use a number of components so in the example apps this adds up to about 15 kb for each app.

While the DataFormsJS Framework is small it will generally be used with a larger Templating or View Engine:

* Handlebars: ~ 22 kb
* Vue: ~ 33 kb
* Underscore: ~ 6 kb
* Nunjucks - ~ 25 kb

Additionally in a complex or large site third-party code is expected to account for the largest amount of JavaScript. For example CodeMirror Text Editor used on the Playground site is around 250 kb, however DataFormsJS has the ability to download only third-party code when it will be needed.

**What are the future plans for DataFormsJS?**

DataFormsJS is here for the long run and will be developed indefinitely with new features, components, examples, docs, etc. While DataFormsJS is a Framework it also includes standalone web components which can be used without the Framework. Over time many additional framework plugins and web components will be developed.

DataFormsJS will continue to be developed in a manner that allows for web based development (for example: the playground site) and will be kept small in size loading scripts only when needed.

## :memo: License

This project is licensed under the **MIT License** - see the [LICENSE](LICENSE) file for details.
