// @link https://www.dataformsjs.com
// @author Conrad Sollitt (http://www.conradsollitt.com)
// @license MIT
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.DataFormsJS=exports.LeafletMap=exports.Format=exports.I18n=exports.SortableTable=exports.InputFilter=exports.JsonData=exports.PolyfillService=exports.ErrorBoundary=void 0;var _react=_interopRequireDefault(require("react"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _instanceof(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!_instanceof(e,t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),e}function _possibleConstructorReturn(e,t){return!t||"object"!==_typeof(t)&&"function"!=typeof t?_assertThisInitialized(e):t}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}var ErrorBoundary=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).state={error:null,errorInfo:null},t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"componentDidCatch",value:function(e,t){this.setState({error:e,errorInfo:t})}},{key:"render",value:function(){return this.state.errorInfo?_react.default.createElement("div",null,_react.default.createElement("h2",{style:{textAlign:"left",color:"white",backgroundColor:"#bc0000",padding:"1em"}},"An error has occurred"),_react.default.createElement("details",{style:{whiteSpace:"pre-wrap",textAlign:"left",color:"white",backgroundColor:"red",padding:"1em"}},this.state.error&&this.state.error.toString(),_react.default.createElement("br",null),this.state.errorInfo.componentStack)):this.props.children}}]),r}();exports.ErrorBoundary=ErrorBoundary;var PolyfillService=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).state={isReady:!1},t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"componentDidMount",value:function(){var e=this,t=!!(Array.from&&window.Promise&&window.fetch);this.loadScript(t,"https://polyfill.io/v3/polyfill.min.js?features=Array.from,Array.isArray,Object.assign,URL,fetch,Promise,Promise.prototype.finally,String.prototype.endsWith,String.prototype.startsWith,String.prototype.includes,String.prototype.repeat",function(){e.setState({isReady:!0})})}},{key:"loadScript",value:function(e,a,t){function r(e,t){var r=document.createElement("script");r.onload=function(){e()},r.onerror=function(){console.error("Error loading Script: "+a),t()},r.src=a,document.head.appendChild(r)}if(!1===e||void 0===e){if(void 0===t)return new Promise(function(e,t){r(e,t)});r(t,t)}else{if(void 0===t)return new Promise(function(e){e()});t()}}},{key:"render",value:function(){return this.state.isReady?this.props.children:null}}]),r}();exports.PolyfillService=PolyfillService;var dataCache=[];function saveDataToCache(e,t,r){for(var a=0,n=dataCache.length;a<n;a++){var o=dataCache[a];if(o.url===e)return o.params=JSON.stringify(t),void(o.data=r)}dataCache.push({url:e,params:JSON.stringify(t),data:r})}function getDataFromCache(e,t){for(var r=0,a=dataCache.length;r<a;r++){var n=dataCache[r];if(n.url===e){if(JSON.stringify(t)===n.params)return n.data;break}}return null}function IsLoading(e){return 0===e.fetchState&&e.children?e.children:null}function HasError(e){if(!(-1===e.fetchState)||!e.children)return null;var t=e.error;return"string"==typeof t&&-1===t.indexOf("Error")&&(t="Error - "+t),_react.default.cloneElement(e.children,{error:t})}function IsLoaded(e){return 1===e.fetchState?_react.default.cloneElement(e.children,{data:e.data,params:e.params,handleChange:e.handleChange}):null}var JsonData=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e)))._isFetching=!1,t._isMounted=!1,t.fetchData=t.fetchData.bind(_assertThisInitialized(t)),t.handleChange=t.handleChange.bind(_assertThisInitialized(t)),t.state={fetchState:0,error:null,params:t.getUrlParams(),data:null},t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"getUrlParams",value:function(){var e={};for(var t in this.props)"url"!==t&&"string"==typeof this.props[t]&&(e[t]=this.props[t]);return e}},{key:"componentDidMount",value:function(){if(this._isMounted=!0,this.props.loadOnlyOnce){var e=getDataFromCache(this.props.url,this.getUrlParams());if(null!==e)return void this.setState({fetchState:1,data:e})}this.fetchData()}},{key:"componentDidUpdate",value:function(e,t){this.buildUrl(t.params)!==this.buildUrl(this.props)&&this.setState({params:this.getUrlParams()},this.fetchData)}},{key:"componentWillUnmount",value:function(){this._isMounted=!1}},{key:"buildUrl",value:function(e){var t=this.props.url;if(0<Object.keys(e).length)for(var r in e)-1<t.indexOf(":"+r)&&(t=t.replace(new RegExp(":"+r,"g"),encodeURIComponent(e[r])));return t}},{key:"fetchData",value:function(){var t=this,e=this.buildUrl(this.state.params);if(!this._isFetching){this._isFetching=!0;var r={mode:"cors",cache:"no-store",credentials:"same-origin"};this.props.fetchOptions&&(r=this.props.fetchOptions),this.props.fetchHeaders&&(r.headers=this.props.fetchHeaders),this.setState({fetchState:0},function(){fetch(e,r).then(function(e){var t=e.status;if(200<=t&&t<300||304===t)return Promise.resolve(e);var r="Error loading data. Server Response Code: "+t+", Response Text: "+e.statusText;return Promise.reject(r)}).then(function(e){return e.json()}).then(function(e){t._isMounted&&t.setState({fetchState:1,data:e}),t.props.loadOnlyOnce&&saveDataToCache(t.props.url,t.getUrlParams(),e)}).catch(function(e){t._isMounted&&t.setState({fetchState:-1,error:e.toString()})}).finally(function(){t._isFetching=!1,t.updateView()})})}}},{key:"handleChange",value:function(e){var t=0<arguments.length&&void 0!==e?e:null;this._isMounted&&this.setState({data:null===t?this.state.data:t})}},{key:"updateView",value:function(){"function"==typeof this.props.onViewUpdated&&this.props.onViewUpdated()}},{key:"render",value:function(){return _react.default.createElement(_react.default.Fragment,null,_react.default.createElement(IsLoading,{fetchState:this.state.fetchState},this.props.isLoading),_react.default.createElement(HasError,{fetchState:this.state.fetchState,error:this.state.error},this.props.hasError),_react.default.createElement(IsLoaded,{fetchState:this.state.fetchState,data:this.state.data,params:this.state.params,handleChange:this.handleChange},this.props.isLoaded))}}]),r}();exports.JsonData=JsonData;var InputFilter=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).onChange=t.onChange.bind(_assertThisInitialized(t)),t.input=_react.default.createRef(),t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"componentDidMount",value:function(){this.filter()}},{key:"onChange",value:function(){this.filter()}},{key:"filter",value:function(){var e=this.input.current,t=e.value.toLowerCase().split(" "),r=t.length,a=0!==r,n=0,o=null,l=null,i=document.querySelectorAll(this.props["filter-selector"]);if(1===i.length&&"TABLE"===i[0].tagName&&i[0].tHead&&1===i[0].tHead.rows.length&&1===i[0].tBodies.length){var s=i[0];o=s.getAttribute("data-sort-class-odd"),l=s.getAttribute("data-sort-class-even"),i=i[0].tBodies[0].rows}for(var u=i.length,c=l&&o,f=0,d=i.length;f<d;f++){var p=i[f],h=!0;if(a)for(var m=p.textContent.toLowerCase(),g=0;g<r;g++)if(""!==t[g]&&!m.includes(t[g])){h=!1;break}h&&(n++,c&&(n%2==0?(p.classList.add(l),p.classList.remove(o)):(p.classList.add(o),p.classList.remove(l)))),p.style.display=h?"":"none"}var v=e.getAttribute("filter-results-selector");if(v){var y=document.querySelector(v);if(!y)return void console.warn("Defined [filter-results-selector] but element not found");var b,C=e.getAttribute("filter-results-text-all"),_=e.getAttribute("filter-results-text-filtered");if(!C)return void console.warn("Defined [filter-results-selector] without [filter-results-text-all]");if(!_)return void console.warn("Defined [filter-results-selector] without [filter-results-text-filtered]");b=(b=n===u?C:_.replace(/{displayCount}/g,n)).replace(/{totalCount}/g,u),y.textContent=b}}},{key:"render",value:function(){return _react.default.createElement("input",Object.assign({},this.props,{onChange:this.onChange,ref:this.input}))}}]),r}();exports.InputFilter=InputFilter;var SortableTable=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).sortColumn=t.sortColumn.bind(_assertThisInitialized(t)),t.table=_react.default.createRef(),t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"componentDidMount",value:function(){this.setupTable()}},{key:"setupTable",value:function(){var e=this.table.current;if(null===e.tHead)return console.warn("Unable to setup sorting for table because there is no <thead> element"),void console.log(e);if(0===e.tHead.rows.length)return console.warn("Unable to setup sorting for table because the <thead> element contained now rows"),void console.log(e);if(0===e.tBodies.length)return console.warn("Unable to setup sorting for table because the <tbody> element is missing"),void console.log(e);if(1!==e.tBodies.length)return console.warn("Unable to setup sorting for table because there can only be one <tbody> element for the table"),void console.log(e);for(var t=e.tHead.rows[e.tHead.rows.length-1],r=0,a=t.cells.length;r<a;r++)t.cells[r].addEventListener("click",this.sortColumn),t.cells[r].style.cursor="pointer"}},{key:"sortColumn",value:function(e){var t=e.target,r=t&&t.parentElement&&t.parentElement.parentElement?t.parentElement.parentElement.parentElement:null;if("TH"!==t.tagName&&"TD"!==t.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the cell needs to be passed."),void console.log(t);if(null!=r&&"TABLE"!==r.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the table cell of the last row from the table header should be used."),void console.log(t);var a=r.getAttribute("data-sort-column"),n=t.cellIndex,o="asc";null!==a&&parseInt(a,10)===n&&(o="asc"===r.getAttribute("data-sort-order")?"desc":"asc");for(var l=r.tBodies[0],i=l.rows,s=[],u=0,c=i.length;u<c;u++){var f=i[u].cells[n];if(void 0!==f){var d=f.getAttribute("data-value"),p=null!==d?d.trim():f.textContent.trim(),h=_typeof(p);if(""===p)p=null;else if(isNaN(p)){var m=new Date(p);isNaN(m.getTime())?p=void 0!==p.toLocaleLowerCase?p.toLocaleLowerCase():p.toLowerCase():(p=m,h="date")}else p=parseFloat(p);s.push({row:i[u],value:p,type:null===p?null:h})}}s.sort(this.sortCompare),"desc"===o&&s.reverse();for(var g=r.getAttribute("data-sort-class-odd"),v=r.getAttribute("data-sort-class-even"),y=g&&v,b=0,C=0,_=s.length;C<_;C++){var w=s[C].row;y&&"none"!==w.style.display&&(++b%2==0?(w.classList.add(v),w.classList.remove(g)):(w.classList.add(g),w.classList.remove(v))),l.appendChild(w)}r.setAttribute("data-sort-column",n),r.setAttribute("data-sort-order",o)}},{key:"sortCompare",value:function(e,t){return null===e.type&&null!==t.type?-1:null===t.type&&null!==e.type?1:null===e.type&&null===t.type?0:"number"===e.type&&"number"!==t.type?-1:"number"===t.type&&"number"!==e.type?1:"number"===e.type&&"number"===t.type?e.value-t.value:"date"===e.type&&"date"!==t.type?-1:"date"===t.type&&"date"!==e.type?1:"date"===e.type&&"date"===t.type?e.value<t.value?-1:e.value>t.value?1:0:"string"===e.type&&"string"===t.type?void 0!==e.value.localeCompare?e.value.localeCompare(t.value):e.value<t.value?-1:e.value>t.value?1:0:(console.warn("A code change from [SortableTable] impacted sorting and caused an expected error so the data may appear out of order. Please review your code changes"),0)}},{key:"render",value:function(){return _react.default.createElement("table",Object.assign({},this.props,{ref:this.table}),this.props.children)}}]),r}();exports.SortableTable=SortableTable;var I18n=function(){function n(e,t){var r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"_",a=3<arguments.length&&void 0!==arguments[3]?arguments[3]:"i18n";if(_classCallCheck(this,n),"string"!=typeof e)throw new Error("Error - I18n - Missing default locale See examples for usage.");if(!Array.isArray(t))throw new Error("Error - I18n - Missing or invalid supported locales. See examples for usage.");this.state={fileName:r,fileDir:a,defaultLocale:e,supportedLocales:t,currentLocale:null,langText:{},langCache:{},startCallback:null,loadedCallback:null},window.addEventListener("hashchange",this.onHashChange.bind(this)),this.onHashChange()}return _createClass(n,[{key:"onLangStart",value:function(e){this.state.startCallback=e}},{key:"onLangLoaded",value:function(e){this.state.loadedCallback=e}},{key:"onHashChange",value:function(){var a=this,n=this.state,e=null;if(0===window.location.hash.indexOf("#/")&&(""!==(e=window.location.hash.split("/")[1])&&-1!==n.supportedLocales.indexOf(e)||(e=null)),null===e&&(e=n.defaultLocale),n.currentLocale!==e){n.currentLocale=e,this.state.startCallback&&this.state.startCallback();var o=n.fileDir+"/"+n.fileName+"."+n.currentLocale+".json";if(void 0!==n.langCache[o])n.langText=n.langCache[o],a.updatePageTitle(),n.loadedCallback&&n.loadedCallback();else if(void 0!==window.fetch)fetch(o,{mode:"cors",cache:"no-store",credentials:"same-origin"}).then(function(e){var t=e.status;if(200<=t&&t<300||304===t)return Promise.resolve(e);var r="Error loading data. Server Response Code: "+t+", Response Text: "+e.statusText;return Promise.reject(r)}).then(function(e){return e.json()}).then(function(e){n.langCache[o]=e}).catch(function(e){var t="Error Downloading I18N file: ["+o+"], Response Code Status: "+e.message;console.error(t),n.langCache[o]={}}).finally(function(){n.langText=n.langCache[o],a.updatePageTitle(),n.loadedCallback&&n.loadedCallback()});else{var t=new XMLHttpRequest;t.open("GET",o),t.onload=function(){var t=null;try{var e=this.status;200<=e&&e<300||304===e?n.langCache[o]=JSON.parse(this.responseText):t="Response Status Code: "+e}catch(e){t=e.toString()}if(null!==t){var r="Error Downloading I18N file: ["+o+"], Error: "+t;console.error(r),n.langCache[o]={}}n.langText=n.langCache[o],a.updatePageTitle(),n.loadedCallback&&n.loadedCallback()},t.send()}}}},{key:"updatePageTitle",value:function(){var e=document.querySelector("html title[data-i18n]");e&&(e.textContent=this.text(e.getAttribute("data-i18n")))}},{key:"text",value:function(e){return this.state.langText&&this.state.langText[e]?this.state.langText[e]:e}},{key:"currentLocale",get:function(){return this.state.currentLocale}}]),n}();exports.I18n=I18n;var Format=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"number",value:function(e){return formatNumber(e,{})}},{key:"currency",value:function(e,t){return formatNumber(e,{style:"currency",currency:t,maximumFractionDigits:2})}},{key:"percent",value:function(e,t){var r=1<arguments.length&&void 0!==t?t:0;return formatNumber(e,{style:"percent",maximumFractionDigits:r,minimumFractionDigits:r})}},{key:"date",value:function(e){return formatDateTime(e,{})}},{key:"dateTime",value:function(e){return formatDateTime(e,{year:"numeric",month:"numeric",day:"numeric",hour:"numeric",minute:"numeric",second:"numeric"})}},{key:"time",value:function(e){return formatDateTime(e,{hour:"numeric",minute:"numeric",second:"numeric"})}}]),e}();function isNumber(e){return!isNaN(parseFloat(e))&&isFinite(e)}function formatDateTime(t,r){if(void 0===window.Intl)return t;try{if(_instanceof(t,Date))return new Intl.DateTimeFormat(navigator.language,r).format(t);var e=new Date(t);return new Intl.DateTimeFormat(navigator.language,r).format(e)}catch(e){return console.warn("Error formatting Date/Time Value:"),console.log(navigator.language),console.log(r),console.log(t),console.log(e),"Error"}}function formatNumber(t,r){var e,a,n,o,l,i=null,s=null,u=null;if(l=navigator.language?navigator.language:navigator.userLanguage,null===t||""===t)return null;if(!isNumber(t))return console.warn("Warning value specified in DateFormsJS Handlebars Helper function formatNumber() is not a number:"),console.log(t),t;if(void 0===window.Intl){if(e=r.style?r.style:null,a=r.maximumFractionDigits?r.maximumFractionDigits:0,"percent"===e)return(100*t).toFixed(a)+"%";switch(l){case"en-us":i=",",s=".",u="$"}return null!==i?((n=t.toString().split("."))[0]=n[0].replace(/\B(?=(\d{3})+(?!\d))/g,","),o=n.join(s),"currency"===e?u+o:o):t}try{return new Intl.NumberFormat(l,r).format(t)}catch(e){return console.warn("Error formatting Numeric Value:"),console.log(l),console.log(r),console.log(t),console.log(e),"Error"}}exports.Format=Format;var LeafletMap=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).div=_react.default.createRef(),t}return _inherits(r,_react.default.Component),_createClass(r,[{key:"componentDidMount",value:function(){for(var e=parseFloat(this.props.latitude),t=parseFloat(this.props.longitude),r=parseInt(this.props.zoom,10),a=this.props.marker,n=[{attr:"latitude",value:e},{attr:"longitude",value:t},{attr:"zoom",value:r}],o=0,l=n.length;o<l;o++)if(isNaN(n[o].value))return console.error("<LeafletMap> - Invalid Prop for ["+n[o].attr+"], value was not a number."),console.log(n[o].attr),void console.log(this.props);var i=L.map(this.div.current).setView([e,t],r);if(L.tileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",{attribution:'&copy; <a href="http://osm.org/copyright" target="_blank">OpenStreetMap</a> contributors'}).addTo(i),null!==a){var s=L.marker([e,t]).addTo(i);a&&s.bindPopup(a),s.openPopup()}}},{key:"render",value:function(){return _react.default.createElement("div",{className:"leaflet-map",ref:this.div})}}]),r}();exports.LeafletMap=LeafletMap;var DataFormsJS=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"ErrorBoundary",get:function(){return ErrorBoundary}},{key:"PolyfillService",get:function(){return PolyfillService}},{key:"JsonData",get:function(){return JsonData}},{key:"InputFilter",get:function(){return InputFilter}},{key:"SortableTable",get:function(){return SortableTable}},{key:"Format",get:function(){return Format}},{key:"I18n",get:function(){return I18n}},{key:"LeafletMap",get:function(){return LeafletMap}}]),e}();exports.DataFormsJS=DataFormsJS;